/**
 * @file file_filter.h
 * @brief t@CtB^
 */
//---------------------------------------------------------------------------
#ifndef FileFilterH
#define FileFilterH

//---------------------------------------------------------------------------
UnicodeString GetFilterInfStr(UnicodeString filter, bool is_grep);
bool TestFilter(UnicodeString filter, bool is_grep);

//---------------------------------------------------------------------------
enum FilterOpt {foIsGrep, foExcludeTag};
typedef Set <FilterOpt, foIsGrep, foExcludeTag> FilterOption;

//---------------------------------------------------------------------------
/**
 * @brief t@CtB^
 */
class FileFilter
{
private:
	bool GetBlockRange(UnicodeString tag);
	void SetHtmlComent();

public:
	UnicodeString FileName;
	UnicodeString Filter;
	TStringList *FileBuff;
	bool isGrep;
	bool excludeTag;

	int topLine;
	int endLine;
	int strIndex;
	int strLength;
	UnicodeString objType;
	UnicodeString propName;

	/** @brief RXgN^ */
	FileFilter();

	~FileFilter();

	/**
	 * @brief 
	 * @param fnam t@C
	 * @param fbuf t@Cobt@
	 * @param filter tB^
	 * @param opt IvV
	 * @return true 
	 * @return false 
	 */
	bool Initialize(UnicodeString fnam, TStringList *fbuf, UnicodeString filter, FilterOption opt);

	/**
	 * @brief se̎擾
	 * @param idx CfbNX
	 * @param[out] r_idx Jnʒu
	 * @param[out] r_len 
	 * @param[out] lbuf \pse
	 * @return UnicodeString ΏۂƂȂ镶
	 */
	UnicodeString GetLinePart(int idx, int &r_idx, int &r_len, UnicodeString &lbuf);

	/**
	 * @brief \pse擾
	 * @param idx CfbNX
	 * @return UnicodeString \pse
	 */
	UnicodeString GetDispLine(int idx);

	/**
	 * @brief ΏۍsH
	 * @param idx CfbNX
	 * @return true Ώۍs
	 */
	bool IsValidLine(int idx);
};
//---------------------------------------------------------------------------
#endif
