/**
 * @file usr_wic.h
 * @brief WIC֘Å֐
 */
//---------------------------------------------------------------------------
#ifndef UserWicH
#define UserWicH

//---------------------------------------------------------------------------
#define WICIMG_FRAME		0
#define WICIMG_PREVIEW		1
#define WICIMG_THUMBNAIL	2

/** t[DIɎ擾gq */
#define FEXT_FRAME_PRI		_T(".bmp.png.gif.tif.wdp.hdp.jpg.jpeg.jpe.webp.heic.eps.psd")

//---------------------------------------------------------------------------

/**
 * @brief WICgR[fbNꗗ̎擾
 * @param[out] lst ꗗ
 * @param[out] fxstr gq
 * @return int ڐ
 */
int WIC_get_ex_list(TStringList *lst, UnicodeString *fxstr = NULL);

/**
 * @brief ew`ŃfR[hărbg}bv擾
 * @param ms ΏۃXg[
 * @param[out] o_bmp o̓rbg}bv
 * @param fmt Rei`GUID
 * @return true 
 * @return false s
 */
bool WIC_get_from_memory(TMemoryStream *ms, Graphics::TBitmap *o_bmp, GUID fmt);

/**
 * @brief t@Cw肵ނ̃rbg}bv擾
 * @param fnam t@C
 * @param[out] o_bmp o̓rbg}bv
 * @param img_type (WICIMG_FRAME, WICIMG_PREVIEW, WICIMG_THUMBNAIL)
 * @return true 
 * @return false s
 */
bool WIC_load_image(UnicodeString fnam, Graphics::TBitmap *o_bmp, int img_type = WICIMG_PREVIEW);

/**
 * @brief rbg}bvw`Ńt@Cɕۑ
 * @param fnam t@C
 * @param[in] i_bmp rbg}bv
 * @param jpg_q JPEG掿(0`100)
 * @param jpg_ycrcb JPEGTuTvO(0`3)
 * @param grayscale jpeg/PNG O[XP[(8bit)ŕۑ
 * @param tif_cmp TIFFk(0`7)
 * @return true 
 * @return false s
 */
bool WIC_save_image(UnicodeString fnam, Graphics::TBitmap *i_bmp,
	int jpg_q = 100, int jpg_ycrcb = 0, bool grayscale = false, int tif_cmp = 0);

/**
 * @brief 摜̏kEg
 * @param[in] i_bmp ̓rbg}bv
 * @param[out] o_bmp o̓rbg}bv
 * @param ratio {(0.0:)
 * @param s_wd TCY(0:)
 * @param s_hi cTCY
 * @param s_opt ASY
 *
 * {TCŶꂩw肵ĂB
*
 * @return true 
 * @return false s
 */
bool WIC_resize_image(Graphics::TBitmap *i_bmp, Graphics::TBitmap *o_bmp,
	float ratio, unsigned int s_wd = 0, unsigned int s_hi = 0, int s_opt = 0);

/**
 * @brief wTCYɎ܂悤ɏkEgA؂o
 * @param[in] i_bmp ̓rbg}bv
 * @param[out] o_bmp o̓rbg}bv
 * @param s_wd TCY
 * @param s_hi cTCY
 * @param s_opt ASY
 * @return true 
 * @return false s
 */
bool WIC_fit_trim_image(Graphics::TBitmap *i_bmp, Graphics::TBitmap *o_bmp,
	unsigned int s_wd, unsigned int s_hi, int s_opt = 0);

/**
 * @brief 摜̉]E]
 * @param[in,out] i_bmp o̓rbg}bv
 * @param rot_opt 1:90/ 2:180/ 3:270(90)/ 4:E]/ 5:㉺]
 * @return true 
 * @return false s
 */
bool WIC_rotate_image(Graphics::TBitmap *i_bmp, int rot_opt);

/**
 * @brief 摜̃O[XP[
 * @param[in,out] i_bmp o̓rbg}bv
 * @return true 
 * @return false s
 */
bool WIC_grayscale_image(Graphics::TBitmap *i_bmp);

/**
 * @brief 摜̃TCY擾
 * @param fnam t@C
 * @param[out] wd  
 * @param[out] hi 
 * @return true 
 * @return false s
 */
bool WIC_get_img_size(UnicodeString fnam, unsigned int *wd, unsigned int *hi);

//---------------------------------------------------------------------------
#endif
