/**
 * @file grep_thread.h
 * @brief GREPXbh
 */
//---------------------------------------------------------------------------
#ifndef TGrepThreadH
#define TGrepThreadH

//---------------------------------------------------------------------------
#include <System.Classes.hpp>

//---------------------------------------------------------------------------
#define MAX_GREP_THREAD		4		//!< őXbh
#define REFRESH_INTERVAL	250		//!< CtH[̍XVԊu

//---------------------------------------------------------------------------
enum GrepOpt {goRegEx, goAnd, goCaseSens, goWord, goOneMatch, goExcludeTag};

/*** @brief IvV */
typedef Set <GrepOpt, goRegEx, goExcludeTag> GrepOption;

//---------------------------------------------------------------------------
/**
 * @brief GREPXbh
 */
class TGrepThread : public TThread
{
private:
	void __fastcall Execute();

	int ID;						//!< XbhID
	int IndexTag;				//!< CfbNX^O
	UnicodeString FileName;		//!< Ώۃt@C
	UnicodeString Keyword;		//!< 
	UnicodeString Filter;		//!< tB^
	GrepOption    Options;		//!< IvV

	TStringList *ResultList;
	void __fastcall AddResult();

public:
	/**
	 * @brief RXgN^
	 * @param CreateSuspended 
	 * @param id XbhID
	 * @param idx_tag CfbNX^O
	 * @param fnam Ώۃt@C
	 * @param kwd 
	 * @param opt IvV
	 * @param filter tB^
	 */
	__fastcall TGrepThread(bool CreateSuspended, int id,
					int idx_tag, UnicodeString fnam, UnicodeString kwd,
					GrepOption opt, UnicodeString filter = EmptyStr);
};
//---------------------------------------------------------------------------
#endif
