/**
 * @file usr_swatch.h
 * @brief XEHb`ubNEpl
 */
//---------------------------------------------------------------------------
#ifndef UsrSwatchPanelH
#define UsrSwatchPanelH

//---------------------------------------------------------------------------
#define MAX_SWATCH_COLOR	128
#define SWATCH_FILE	  "Swatchbook.INI"	//!< F{

//---------------------------------------------------------------------------
extern int SWATCH_ColTable[MAX_SWATCH_COLOR];

/**
 * @brief XEHb`ubNH
 * @param fnam t@C
 * @return true XEHb`ubN
 */
bool IsSwatchbook(UnicodeString fnam);

/**
 * @brief XEHb`ubNt@Cɕۑ
 * @param fnam t@C
 * @return true 
 */
bool SaveSwatchbook(UnicodeString fnam);

/**
 * @brief XEHb`ubNt@Cǂݍ
 * @param fnam t@C
 * @param tmp_sw SWATCH_ColBuff ɈꎞǍ
 * @return int J[
 */
int  LoadSwatchbook(UnicodeString fnam, bool tmp_sw = false);

/**
 * @brief JX^J[ݒ
 * @param lst 
 */
void SetCustomColToSwatch(TStrings *lst);

/**
 * @brief ` (168s)
 * @param cv LoX
 * @param rc `̈
 * @param tmp_sw SWATCH_ColBuff ̓e`
 */
void DrawSwatchbook(TCanvas *cv, TRect rc, bool tmp_sw = false);

//---------------------------------------------------------------------------
/**
 * @brief XEHb`ubNEpl
 */
class UsrSwatchPanel : public TPanel
{
private:
	TPaintBox *SwatchPaintBox;
	void __fastcall SwatchPaintBoxPaint(TObject *Sender);

public:
	/** @brief RXgN^*/
	__fastcall UsrSwatchPanel(TComponent* Owner);

	/**
	 * @brief 168ĩplTCY^CTCYɊÂĐݒ
	 * @param tile_size ^CTCY
	 */
	void __fastcall SetPanelSize16x8(int tile_size);
};
//---------------------------------------------------------------------------
#endif
